HackerRank: N Puzzle
airbnb面试题汇总
https://www.codeproject.com/Articles/368188/AI-Sliding-Puzzle-Solution-Analyzer
BFS algorithm also works without history, but due to the loopy structure of the sliding puzzle, the search space becomes unbounded. Hence, filling up the memory before the solution is found to become extremely possible. On the algorithm tests, it is seen that BFS cannot solve puzzles exceeding 15 steps in a reasonable time (2-3 minutes). However, after implementing history, it can reach to 25 steps in a reasonable time.
N Puzzle is a sliding blocks game that takes place on a k * k grid with ((k * k) - 1) tiles each numbered from 1 to N. Your task is to reposition the tiles to their proper order.
N-Puzzle is a classic 1 player game that teaches the basics of heuristics in arriving at solutions in Artificial Intelligence.
The final configuration of an 8 - puzzle will look like
0 1 2
3 4 5
6 7 8
A* algorithm talks about a cost function and a heuristic.
cost = heuristic_cost + #of steps taken to reach the current state.
the tiles are numbered. For a given unsolved 8 - puzzle configuration say
0 3 8
4 1 7
2 6 5
We use 2 heuristics for every state and at every iteration
1 such heuristic is
h1 => The number of misplaced tiles.
In the above example, the number of misplaced tiles are 8
2nd heuristic we use is
h2 => The manahattan distance between a tile's original position to its current position.
In the above example, the manhattan distance for all tiles are as follows
ab => where a is the manhattan distance of tile b.
h2 = 23 + 28 + 14 + 11 + 27 + 42 + 16 + 15
h2 = 14
Given 2 heuristics, it is always advised to use the maximum as the maximum never underestimates the cost to reach the required end state ( initial configuration of 8 Puzzle )
If it took 10 moves to reach the current state as shown above, then the cost function of a given state of N - puzzle
is given as
cost = max( h1, h2 ) + 10
cost = max( 14, 8 ) + 10 = 24
We can then implement a priority queue and record each of possible moves from a given initial state of the board and then pop the state with the lowest cost function. This procedure is guaranteed to give us a solution.
airbnb面试题汇总
九宫格,一共8个方块,从1-8,一个方块空出来,然后打乱之后通过SLIDE还原,这个题要推广到N宫格,先实现这个游戏,然后对于一个任意的BOARD,要你把他解出来
def dis(x, y): # A* evaluation func
return (x - 2) ** 2 + (y - 2) ** 2
def play(board):
m, n = len(board), len(board[0])
x, y = 0, 0
for i in xrange(m):
for j in xrange(n):
if board[i][j] == '0':
x, y = i, j
board_key = ''.join(''.join(row) for row in board)
heap = [(dis(x, y), x, y, board_key)]
visited = set()
while heap:
_, x, y, cur = heapq.heappop(heap)
if cur in visited:
continue
visited.add(cur)
if cur == "123456780":
return True
for dx, dy in zip((1, -1, 0, 0), (0, 0, 1, -1)):
new_x, new_y = x + dx, y + dy
if 0 <= new_x < m and 0 <= new_y < n:
pos1, pos2 = x * m + y, new_x * m + new_y
new_board = list(cur)
new_board[pos1], new_board[pos2] = new_board[pos2], new_board[pos1]
heapq.heappush(heap, (dis(new_x, new_y), new_x, new_y, ''.join(new_board)))
return False
typedef tuple<int, int, int, string> boardInfo;
bool validSlidingGame(vector<vector<int> >& board) {
const int m = board.size(), n = board[0].size();
auto dis = [](int x, int y, int z, int p) {return (x - z) * (x - z) + (y - p) * (y - p); };
int x = 0, y = 0;
string key = "";
const int dir[4][2] = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};
priority_queue<boardInfo> pq;
unordered_set<string> visited;
for (int i = 0; i < m; ++i) {
for (int j = 0; j < n; ++j) {
if (board[i][j] == 0) {
x = i, y = j;
}
key += to_string(board[i][j]);
}
}
pq.push(make_tuple(-dis(x, y, m - 1, n - 1), x, y, key));
visited.insert(key);
while (!pq.empty()) {
auto tp = pq.top();
pq.pop();
string curKey;
tie(ignore, x, y, curKey) = tp;
// x = get<1>(tp), y = get<2>(tp);
// auto curKey = get<3>(tp);
if (curKey == "123456780") return true;
for (int i = 0; i < 4; ++i) {
int newX = x + dir[i][0];
int newY = y + dir[i][1];
if (newX >= 0 && newX < m && newY >= 0 && newY < n) {
swap(curKey[x * m + y], curKey[newX * m + newY]);
if (!visited.count(curKey)) {
pq.push(make_tuple(-dis(newX, newY, m - 1, n - 1), newX, newY, curKey));
visited.insert(curKey);
}
}
}
}
return false;
}
https://medium.com/towards-data-science/solve-slide-puzzle-with-hill-climbing-search-algorithm-d7fb93321325https://www.codeproject.com/Articles/368188/AI-Sliding-Puzzle-Solution-Analyzer
BFS algorithm also works without history, but due to the loopy structure of the sliding puzzle, the search space becomes unbounded. Hence, filling up the memory before the solution is found to become extremely possible. On the algorithm tests, it is seen that BFS cannot solve puzzles exceeding 15 steps in a reasonable time (2-3 minutes). However, after implementing history, it can reach to 25 steps in a reasonable time.